// Craig S. Kaplan

// Take a folder hierarchy and turn it into a JSON file, just to 
// see what happens.  You can then count up the number of files
// in the hierarchy by writing a cute recursive function on the
// JSON object.

void setup()
{
  JSONObject obj = loadJSONObject( "directory.json" );
  int total_files = countFiles( obj );
  println( total_files );
}

// Watch out, this function is recursive.  The base case is when
// you encounter a file, in which case its count is 1.  The
// recursive case is when you have a folder, in which case you 
// recursively count up the number of files in each of its children.
int countFiles( JSONObject obj )
{
  String type = obj.getString( "type" );
  if( type.equals( "file" ) ) {
    return 1;
  } else {
    int total = 0;
    JSONArray arr = obj.getJSONArray( "children" );
    for( int idx = 0; idx < arr.size(); ++idx ) {
      total += countFiles( arr.getJSONObject( idx ) );
    }
    return total;
  }
}
