// Craig S. Kaplan

// A simple demonstration of loading a JSON object from
// a file and extracting its contents.

void setup()
{
  // Read the main JSON object from a local file.
  JSONObject my_obj = loadJSONObject( "data.json" );
  
  println( "And now, the goose report." );
  
  // If you look in the JSON file, you'll see a line of
  // the form "data:[".  That says that there's a field
  // called "data", and that this field contains an array
  // of values inside of it, stored using the type
  // JSONArray.  This declaration extracts the array from
  // the main object.
  JSONArray arr = my_obj.getJSONArray( "data" );
  
  // Now we can walk over the array, using the methods of
  // JSONArray.
  for( int idx = 0; idx < arr.size(); ++idx ) {
    // This is the way you extract a nested JSONObject 
    // out of an array of objects.
    JSONObject event = arr.getJSONObject( idx );
    
    // Now, what the heck, let's print out some of the
    // interesting fields of this event object.
    println( "==>", event.getString( "location" ) );
    println( "  (" + event.getFloat( "latitude" ) + "N, "
      + abs(event.getFloat( "longitude" )) + "W)" );
    println( "  Last updated: " + event.getString( "updated" ) );
  }
}